<template>
    <v-card elevation-0 tile flat>
    <v-toolbar color="primary" dark flat>
        <v-icon @click="$emit('cancel')">close</v-icon>
        <v-toolbar-title>{{$i18n.t("interview.form.title")}}</v-toolbar-title>
        <v-spacer></v-spacer>
        <v-btn flat dark @click="save" :disabled="saving"><v-icon>save</v-icon>&nbsp;{{saveButtonText}}</v-btn>
    </v-toolbar>
     <v-form ref="interviewForm"> 
        <v-card-text>
            <v-container grid-list-md>
              <v-layout row wrap>
                <v-flex xs12 sm12> 
                    <v-select
                        :items="types" 
                        :label="$i18n.t('interview.form.type')"
                        v-model="interview.type"
                        item-text="text"
                        @change="onchange"
                        :rules="validationRules.notBlank"
                        item-value="value"></v-select>
                </v-flex> 
                
                 <v-flex xs12 v-if="interview.type=='ON_SITE'">  
                   <v-textarea 
                            browser-autocomplete='off' 
                            auto-grow
                            @change="onchange" 
                            :label="$i18n.t('interview.form.location.label')" 
                            name="location" 
                            rows="3" 
                            :hint="$i18n.t('interview.form.location.hint')" 
                            :rules="validationRules.location"
                            v-model="interview.location"/>
                </v-flex>
                
                <v-flex xs12 sm6>
                    <v-dialog
                        v-model="dateDialog"
                        @change="onchange"
                        lazy 
                        full-width
                        width="290px">
                        <v-text-field
                                :value="interviewDate"
                                slot="activator" 
                                :label="$i18n.t('interview.form.date')" 
                                append-icon="event" 
                                :rules="validationRules.notBlank"
                                @keydown.enter.ctrl="dateDialog = !dateDialog"
                                readonly></v-text-field>
                        <v-date-picker v-if="dateDialog" scrollable @input="setDate"></v-date-picker>
                    </v-dialog>
                </v-flex>
                <v-flex xs12 sm6>
                    <v-dialog
                        v-model="timeDialog"
                        lazy
                        @change="onchange"
                        full-width
                        width="290px">
                        <v-text-field
                          slot="activator"
                          :value="interviewTime"
                          :label="$i18n.t('interview.form.time')"
                          append-icon="access_time"
                          :rules="validationRules.notBlank"
                          @keydown.enter.ctrl="timeDialog = !timeDialog"
                          readonly></v-text-field>
                        <v-time-picker v-if="timeDialog" format="24hr" @input="setTime"></v-time-picker>
                     </v-dialog>
                </v-flex>
                
                <v-flex xs12>
                    <v-layout column>
                        <v-flex xs12>
                            <v-text-field 
                                :label="$i18n.t('interview.form.interviewers.label')" 
                                @keydown.enter="addInterviewer" 
                                @blur="addInterviewer" 
                                v-model="interviewer" 
                                :hint="$i18n.t('interview.form.interviewers.hint')"></v-text-field>
                            <v-chip color="primary" close dark 
                                    v-for="(value, index) in interview.interviewers" 
                                    :key="value"
                                    @input="removeInterviewer(index)">
                              <v-avatar>
                                <v-icon>account_circle</v-icon>
                              </v-avatar>
                              <div>
                              {{value}}
                              </div>
                            </v-chip>
                        </v-flex>
                    </v-layout>
                </v-flex> 
                
                <v-flex xs12>
                     <v-textarea 
                            browser-autocomplete='off' 
                            auto-grow 
                            :label="$i18n.t('interview.form.note.label')" 
                            name="note" 
                            rows="5" 
                            :hint="$i18n.t('interview.form.note.hint')" 
                            v-model="interview.description"/>
                </v-flex>
                
              </v-layout>
            </v-container>
        </v-card-text>
      </v-form>
    </v-card>
</template>  

<script>
import moment from 'moment'
export default {
  name: 'InterviewForm',
  props: ['item'],
  data() {
    return {
        interview: this.item || { 
            type: 'PHONE',
            date: new Date(),
            description: null,
            interviewers: [],
            location: null
        },
        interviewer: null,
        //technical fields
        edit: null,
        saving: null,
        valid: true,
        timeDialog: null,
        dateDialog: null,
    }
  },
  mounted() {
    this.onchange();
  },
  methods: {
    validateForm() {
        return this.$refs.interviewForm.validate() 
    },
    onchange() {
        this.valid = this.validateForm();
    },
    setTime(t) {
        const time = moment(t, "h:mm A")
        this.interview.date = moment(this.interview.date)
            .hours(time.hours())
            .minutes(time.minutes()).toDate()
        this.timeDialog = false
    },
    setDate(t) {
        const date = moment(t, "YYYY-MM-DD")
        this.interview.date = moment(this.interview.date)
            .year(date.year())
            .month(date.month())
            .date(date.date()).toDate()
        this.dateDialog = false
    },
    save() {
        this.valid = this.validateForm();
         
        if ( !this.valid ) return;
        
        this.saving = true
        
        try {
            const interview = Object.assign({ }, this.interview);
            this.$emit('save', interview)
        }
        finally {
            this.saving = false
            
            if ( this.mode != 'edit' ) {
                this.$refs.interviewForm.reset()
                this.interview =  { 
                    type: 'PHONE',
                    date: new Date(),
                    description: null,
                    interviewers: [],
                    location: null
                };
            }
        }
    },
    addInterviewer() {
         if (this.interviewer ) {
            this.interview.interviewers.push(this.interviewer)
            this.interviewer = null
        }
    },
    removeInterviewer(index) {
        this.interview.interviewers.splice(index, 1)
    },
  },
  computed: {
    validationRules() {
        return {
            notBlank: [v =>  !!v || this.$i18n.t("interview.form.validation.notBlank")],
            location: [v => !this.interview || this.interview.type != 'ON_SITE' || !!v || this.$i18n.t("interview.form.validation.location")]
        }
    },
    types() {
        return [
            { text: this.$i18n.t("interview.type.phone"), value: 'PHONE' },
            { text: this.$i18n.t("interview.type.video_call"), value: 'VIDEO_CALL' },
            { text: this.$i18n.t("interview.type.on_site"), value: 'ON_SITE' },
            { text: this.$i18n.t("interview.type.screening"), value: 'SCREENING' }
        ]
    },
    interviewTime: {
        get() {
           return this.interview.date ? moment(this.interview.date).format(this.$i18n.t("interview.format.time")) : ''
        }
    },
    interviewDate: {
        get() {
           return this.interview.date ? moment(this.interview.date).format(this.$i18n.t("interview.format.date")) : ''
        }
    },
    saveButtonText() {
        return this.saving ? this.$i18n.t("common.saving") : this.$i18n.t("common.save");
    }
  }
}
</script>